# Druck-Men
#
# Copyright (C) 1994  G. Lamprecht, W. Lotz, R. Weibezahn; LRW c/o Uni Bremen
# Copyright (C) 1996  G. Lamprecht, W. Lotz, R. Weibezahn; IWD, Bremen University


proc dvi2printer {} {# call of printer driver and forewarding of output

proc dmReqPrintNo {} {# output is not to be printed
 global Wq vv prtfilperm prt_file
 destror $Wq
 if {$prtfilperm=="$vv(dm20)"} {unlink -nocomplain $prt_file}
 unlock_list; focus .
}

proc dmReqPrintYes {} {# output is to be printed
 global Wq vv  prtfilperm prt_file
 destror $Wq
 printing .d.tt austext; writescr .d.tt "$austext"
 if {$prtfilperm=="$vv(dm20)"} {unlink -nocomplain $prt_file}
 unlock_list; focus .
}

proc dmWdmae {nonstop} {
 global vv Wdm Wq austext sub prtdriver prt_file prtfilperm lpcmd lpopt olsep printer
 global mkcommand

 dmfocus ""; destros $Wdm; set sub 1
 set ret [prt_$prtdriver .d.tt austext];  writescr .d.tt "$austext"
 if {(($ret=="")||($ret=="0"))&&[file exists $prt_file]} {
   if {$nonstop==0} {
     if {[winfo exists $Wq]==1} {destror $Wq}; toplevel $Wq
     set frage "[eval list $vv(drafrage)]"
     Request $Wq "$frage " "" "$vv(yes)" dmReqPrintYes "$vv(no)" dmReqPrintNo dm_ausdrucken ""
   } else {
     printing .d.tt austext; writescr .d.tt "$austext"
     if {$prtfilperm=="$vv(dm20)"} {unlink -nocomplain $prt_file}
     unlock_list; focus .
   }
 } elseif {$mkcommand=="mkcommand.0"} {
   mkCmd_wait .d.tt $lpcmd [eval list [lindex [split $lpopt $olsep] 1] \
	[lindex [split $lpopt $olsep] 2] $prt_file]
   unlock_list; focus .
 } else {# prt_....tcl aborted or no output file produced by prt_....tcl
   if ![file exists $prt_file] {writescr .d.tt "\n*** $vv(drakd)\n";mybell 3}
   if {$prtfilperm=="$vv(dm20)"} {unlink -nocomplain $prt_file}
   unlock_list; focus .
 }
}

global vv Wdm prtdriver xtem_path mkcommand

if {$prtdriver==""} {
  puts stdout {Error! printer driver name is empty; see Installation Guide ("printing.vst")}
  mybell 4
} else {
  if {[info commands prt_$prtdriver]!="prt_$prtdriver"} {
    if [file exists $xtem_path/prt_${prtdriver}.tcl] {
      source $xtem_path/prt_${prtdriver}.tcl
      if {[info commands prt_$prtdriver]!="prt_$prtdriver"} {
	puts stdout "Error! File \"$xtem_path/prt_${prtdriver}.tcl\" doesn't contain "
	puts stdout "(called) procedure \"prt_$prtdriver\"; see Installation Guide"
	mybell 4; return
      }
    } else {
      puts stdout "Error! Missing file \"$xtem_path/prt_${prtdriver}.tcl\""
      puts stdout "       for called printer driver  \"$prtdriver\"; see Installation Guide"
      mybell 4; return
    }
  }
  if [winfo exists $Wdm] {destros $Wdm}
  printmenu
}

}

##############################################################################################

proc printmenu  {} {

proc dmdsel {s} {
  global Wdm vv dmsep prmtext prmrelabs prmsel start ende pg_start pg_end dmdsel_v prtreversed
  dmfocus ""
  set prmtext [getvalue $s 0 $dmsep]; set prmrelabs [getvalue $s 1 $dmsep]
  set prmsel [getvalue $s 2 $dmsep]; set prtreversed [getvalue $s 3 $dmsep]
  if {$prmrelabs==""} {
   set pg_start "$start"; set pg_end "$ende"; $Wdm.c.2.s delete 0 end; $Wdm.c.2.e delete 0 end
  }
  if     {$prmrelabs=="r"} {set prmrelabst "$vv(dm11)"} \
  elseif {$prmrelabs=="a"} {set prmrelabst "$vv(dm12)"} \
  else                     {set prmrelabst "$vv(dm13)"}
  $Wdm.c.1.d2 configure -text "$vv(dmc1d2) $prmrelabst "
  $Wdm.c.1.d3 configure -text "$vv(dmc1d3) $prmrelabst " 
  dmprtrev nontoggle
  writescr0 $Wdm.d.tt "$vv(dm14)\n$prmtext\n"
  updateWdmb1
  set dmdsel_v "$s"
}

proc dmfocus {w} {
 global Wdm dm_f
 if {$dm_f==1} dmesp elseif {$dm_f==2} dmeep elseif {$dm_f==3} dmefn elseif {$dm_f==4} dmecn
 if {$w!=""} {focus $w} else {focus $Wdm}
}

proc dmesp {} {
 global Wdm vv prmrelabs startvar prmtext pg_start pg_end dm_f
 if {$prmrelabs == ""} {
   $Wdm.c.2.s delete 0 end; writescr0 $Wdm.d.tt "$vv(dm16) \n"; mybell 2
 } elseif {$startvar!=""} {
   set pg_start $startvar; updateWdmb1; writescr0 $Wdm.d.tt "$vv(dm15) $startvar\n"
 }
 set dm_f 0
}

proc dmeep {} {
 global Wdm vv prmrelabs endevar prmtext pg_start pg_end dm_f
 if {$prmrelabs == ""} {
   $Wdm.c.2.e delete 0 end; writescr $Wdm.d.tt "$vv(dm16) \n"; mybell 2
 } elseif {$endevar!=""} {
   set pg_end $endevar; updateWdmb1; writescr0 $Wdm.d.tt "$vv(dm17) $endevar\n"
 }
 set dm_f 0
}

proc dmefn {} {
 global Wdm vv drfnin prt_file prtfilperm dm_f
 if {$drfnin == ""} {
   writescr0 $Wdm.d.tt "$vv(dm23) $prt_file\n"
   $Wdm.c.2.pc.fn delete 0 end; $Wdm.c.2.pc.fn insert end $prt_file
 } else {
   set prt_file $drfnin; writescr0 $Wdm.d.tt  "$vv(dm24) $prt_file\n"
   $Wdm.b.1a configure -text "$vv(dm21) ${prtfilperm}$vv(dm22) $vv(dm18) $prt_file"
 }
 set dm_f 0
}

proc dmecn {} {
 global Wdm vv printcops maxprintcops dm_f
 if {$printcops>$maxprintcops} {
   mybell 2; set printcops $maxprintcops; set t "$vv(dm26)"
 } else {
   if {($printcops=="")||($printcops<="0")} {set printcops 1; mybell 2}
   set t "$vv(dm25)"
 }
 selection clear $Wdm.c.2.pc.cn
 writescr0 $Wdm.d.tt "$t $printcops\n"
 set dm_f 0
}

proc updateWdmb1 {} {
 global Wdm vv prmtext pg_start pg_end
 $Wdm.b.1 configure -text "$prmtext  $vv(dm10) $pg_start - $pg_end)"
}

proc dmprtrev {toggle} {# variable prtreversed undocumented up to now, for future use
 # prtreversed: 3rd parameter in prt_*.vst; vlaues: "" (=unused), 1, 2, -1, -2
 global Wdm vv prtreversed
 if {$prtreversed==""} {pack forget $Wdm.c.1.d4.t $Wdm.c.2.rv.t; return}
 if {$toggle=="toggle"} {if {$prtreversed==1} {set prtreversed 2} {set prtreversed 1}}
 if {($prtreversed==1)||($prtreversed==-1)} {set t $vv(dm4)} else {set t $vv(dm5)}
 pack configure $Wdm.c.1.d4.t $Wdm.c.2.rv.t
 if {$prtreversed<0} {$Wdm.c.2.rv.t configure -state disabled; update idletasks} \
 else {$Wdm.c.2.rv.t configure -state normal; update idletasks}
 $Wdm.c.2.rv.t configure -text "$t"; update
}


global vv Wdm printcops startvar endevar dm_f drfnin button2end
global main_file printer prtdriver prtoptions lpcmd prtfilperm prtsuf prtselstr
global start ende pg_start pg_end prmtext prmsel prmrelabs dmsep prt_file dmdsel_v

toplevel_init $Wdm "$vv(dmvor)" 0 0;  set tyh 19


set start "$vv(dmstart)"; set ende "$vv(dmend)"
set pg_start "$start"; set pg_end "$ende"
set printcops 1


# Bereich a fuer erste Buttons

frame $Wdm.a -relief raised -borderwidth 1; pack configure $Wdm.a -pady 10 -anchor w
 
button $Wdm.a.e -text "O.K." -command "dmWdmae 0"
if {$button2end==2} {
  Bind2P $Wdm.a.e 1 dmWdmae 1;# OK, print without Request-call
  Bind3HTF $Wdm.a.e "$vv(btclk2):\n  $vv(btclk4)\n" dm_OK $Wdm.d.tt
} else {
  Bind3HF $Wdm.a.e dm_OK $Wdm.d.tt
}
button $Wdm.a.a -text "$vv(dmaa)" -command "dmfocus \"\"; destros $Wdm; unlock_list; focus ."
Bind3HF $Wdm.a.a dm_abbruch $Wdm.d.tt
button $Wdm.a.h -text "$vv(ah)" -command {HTxtFile0 "" dm_h $Wdm.d.tt}
Bind2HF $Wdm.a.h dm_h $Wdm.d.tt
Bind3HF $Wdm.a.h dm_h $Wdm.d.tt
button $Wdm.a.l -text "$vv(al)" -command {clearscr $Wdm.d.tt}
Bind3HF $Wdm.a.l z_loeschetf $Wdm.d.tt
pack configure $Wdm.a.e $Wdm.a.a $Wdm.a.h $Wdm.a.l -side left -padx 3 -pady 3


# Bereich bv fuer eigene Einstellungen

frame $Wdm.bv; pack configure $Wdm.bv -pady 13 -anchor w
label  $Wdm.bv.dv -text "$vv(bvdv)" -width 23 -anchor w
Bind3HF $Wdm.bv.dv z_voreinst1 $Wdm.d.tt
button $Wdm.bv.va -text "$vv(bvva)" -command {
  dmfocus ""
  writescr0 $Wdm.d.tt "$vv(aus0)\n\n $vv(dm2)  $vv(dmvon) $pg_start $vv(dmbis) $pg_end\n" \
	" $vv(dm3)  $prmtext ($prmsel)\n\n $vv(dv2)  $printer\n" \
	" $vv(dv4)  $prtdriver\n $vv(dv6)  $prtformat\n" \
	" $vv(dv7)  $prtoptions\n $vv(dv3)  $lpcmd\n $vv(dv8)  $lpopt\n"
}
Bind3HF $Wdm.bv.va z_voreinst1 $Wdm.d.tt
pack configure $Wdm.bv.dv $Wdm.bv.va -side left


# Bereich b fuer Anzeigen und Drucker-Auswahl

frame $Wdm.b; pack configure $Wdm.b -anchor w

if {$prtsuf==".ps"} {set prt_file [stripdir $main_file.print.ps]} \
	else {set prt_file [stripdir $main_file$prtsuf]}
label $Wdm.b.1 -width 96 -anchor w -text "$prmtext  $vv(dm10) $pg_start - $pg_end)"
Bind3HF $Wdm.b.1 dm_anzeig $Wdm.d.tt
label $Wdm.b.1a -width 96 -anchor w \
	-text "$vv(dm21) ${prtfilperm}$vv(dm22) $vv(dm18) $prt_file"
Bind3HF $Wdm.b.1a dm_anzeig $Wdm.d.tt
if {$printer==""} {set t "$vv(dvbad1)"} else {set t "$vv(dvbad2) $prtselstr"}
label $Wdm.b.1b -width 96 -anchor w -text "$t"
Bind3HF $Wdm.b.1b dm_anzeig $Wdm.d.tt
pack configure $Wdm.b.1 $Wdm.b.1a $Wdm.b.1b
set dmsep [getsep prt_${prtdriver}.vst]
if {$prmtext==""} {vstr_driver; set pg_start "$start"; set pg_end "$ende"; updateWdmb1}
CreateLSBox $Wdm.b $vv(dmb2) top 85 8 2 dm_seitena $Wdm.d.tt \
     $dmsep [vst2list prt_${prtdriver}.vst 1 $dmsep "$prmtext" dmdsel_v] dmdsel "" "dmWdmae 0"
if     {$prmrelabs=="r"} {set prmrelabst "$vv(dm11)"} \
elseif {$prmrelabs=="a"} {set prmrelabst "$vv(dm12)"} \
else                     {set prmrelabst "$vv(dm13)"}


# Bereich c fuer Seitenbereich, permanente Datei, Kopienanzahl

frame $Wdm.c; pack configure $Wdm.c -anchor w
frame $Wdm.c.1; frame $Wdm.c.2; pack configure $Wdm.c.1 $Wdm.c.2 -side left -fill x -ipadx 5

# Bereich c1 fuer Label
label $Wdm.c.1.d2 -text "$vv(dmc1d2) $prmrelabst "
label $Wdm.c.1.d3 -text "$vv(dmc1d3) $prmrelabst "
frame $Wdm.c.1.d4; label $Wdm.c.1.d4.t -text "$vv(dmc1d4): "
label $Wdm.c.1.d5 -text "$vv(dm18): "
Bind3HF $Wdm.c.1.d2 dm_seitens $Wdm.d.tt
Bind3HF $Wdm.c.1.d3 dm_seitene $Wdm.d.tt
Bind3HF $Wdm.c.1.d4.t dm_prtrev $Wdm.d.tt
Bind3HF $Wdm.c.1.d5 dm_perm $Wdm.d.tt
pack configure $Wdm.c.1.d2 $Wdm.c.1.d3 $Wdm.c.1.d4 $Wdm.c.1.d5 -anchor e -ipady 1
# $Wdm.c.1.d4.t will be packed in procedure dmprtrev

# Start- und Ende-Seite

entry $Wdm.c.2.s -textvariable startvar -width 20 -relief sunken
      $Wdm.c.2.s icursor 0; $Wdm.c.2.s delete 0 end
entry $Wdm.c.2.e -textvariable endevar -width 20 -relief sunken
      $Wdm.c.2.e icursor 0; $Wdm.c.2.e delete 0 end
frame $Wdm.c.2.rv; frame $Wdm.c.2.pc 
pack configure $Wdm.c.2.s $Wdm.c.2.e $Wdm.c.2.rv $Wdm.c.2.pc -anchor w

if {$pg_start!="$start"} {set startvar "$pg_start"} else {set startvar ""}
if {$pg_end!="$ende"} {set endevar "$pg_end"} else {set endevar ""}
$Wdm.c.2.s insert 0 $startvar; $Wdm.c.2.e insert 0 $endevar

bind $Wdm.c.2.s <Button-1> {dmfocus $Wdm.c.2.s; set dm_f 1}
bind $Wdm.c.2.s <Button-2> {Bend}
Bind3HF $Wdm.c.2.s dm_seitens $Wdm.d.tt
bind $Wdm.c.2.s <Return> {dmesp; focus $Wdm; Bend}

bind $Wdm.c.2.e <Button-1> {dmfocus $Wdm.c.2.e; set dm_f 2}
bind $Wdm.c.2.e <Button-2> {Bend}
Bind3HF $Wdm.c.2.e dm_seitene $Wdm.d.tt
bind $Wdm.c.2.e <Return> {dmeep; focus $Wdm; Bend}


# Druckrichtung

button $Wdm.c.2.rv.t -text "" -width 15 -command {dmprtrev toggle}
Bind3HF $Wdm.c.2.rv.t dm_prtrev $Wdm.d.tt
# $Wdm.c.2.rv.t will be packed in procedure dmprtrev
dmprtrev nontoggle


# nicht/permanente Druckdatei

entry $Wdm.c.2.pc.fn -textvariable drfnin -width 20 -relief sunken
$Wdm.c.2.pc.fn delete 0 end
$Wdm.c.2.pc.fn insert end $prt_file
button $Wdm.c.2.pc.np -text "$prtfilperm" -width 15 -command {
  dmfocus ""
  if {$prtfilperm==$vv(dm20)} {set t $vv(dm19)} else {set t $vv(dm20)}
  set prtfilperm $t; $Wdm.c.2.pc.np configure -text $t
  writescr0 $Wdm.d.tt ""
  $Wdm.b.1a configure -text "$vv(dm21) ${prtfilperm}$vv(dm22) $vv(dm18) $prt_file"
}
pack configure $Wdm.c.2.pc.fn $Wdm.c.2.pc.np -side left

Bind3HF $Wdm.c.2.pc dm_perm $Wdm.d.tt
Bind3HF $Wdm.c.2.pc.np dm_perm $Wdm.d.tt
Bind3HF $Wdm.c.2.pc.fn dm_perm $Wdm.d.tt
bind  $Wdm.c.2.pc.fn <Button-1> {dmfocus $Wdm.c.2.pc.fn; set dm_f 3}
bind  $Wdm.c.2.pc.fn <Button-2> {Bend}
bind  $Wdm.c.2.pc.fn <Return> {dmefn; focus $Wdm}


# Kopienzahl

label $Wdm.c.2.pc.ct -text "  $vv(dmc2ct)"
entry $Wdm.c.2.pc.cn -textvariable printcops -width 10 -relief sunken
pack configure $Wdm.c.2.pc.ct $Wdm.c.2.pc.cn -side left

Bind3HF $Wdm.c.2.pc.ct dm_numcop $Wdm.d.tt
Bind3HF $Wdm.c.2.pc.cn dm_numcop $Wdm.d.tt
bind  $Wdm.c.2.pc.cn <Button-1> {dmfocus $Wdm.c.2.pc.cn;set dm_f 4;$Wdm.c.2.pc.cn icursor end}
bind  $Wdm.c.2.pc.cn <Button-2> {set printcops 1; writescr0 $Wdm.d.tt ""; focus $Wdm; Bend}
bind  $Wdm.c.2.pc.cn <Return> {dmecn; focus $Wdm; Bend}


# Bereich d fuer Hilfe-Ausgaben

InsertTextFrame $Wdm $tyh
 
focus $Wdm; focus $Wdm; set dm_f 0
}
